%global momorel 1
#%%global pre -pre2

# When you have problems with bootstrapping or running cmucl,
# try adding "exec-shield=0" to the kernel command line option at boot time.
# See http://www.cons.org/cmucl/platforms.html for details
%global bootstrap 0
%global cmucl_arch x86

Summary: The CMU Common Lisp compiler.
Name: 	 cmucl
Version: 19e
Release: %{momorel}m%{?dist}
License: Public Domain
Group: 	 Development/Languages
URL:	 http://www.cons.org/cmucl/
Source0: http://common-lisp.net/project/cmucl/downloads/release/%{version}%{?pre:/pre-release}/cmucl-src-%{version}%{?pre}.tar.bz2
NoSource: 0
%if %{bootstrap}
# Existing cmucl binary for bootstrap
Source10: http://common-lisp.net/project/cmucl/downloads/release/%{version}%{?pre:/pre-release}/cmucl-%{version}%{?pre}-%{cmucl_arch}-linux.tar.bz2 
NoSource: 10
%global bootstrap_src -a 10
%else
BuildRequires: cmucl >= 19d
%endif
Patch1: cmucl-19e-gcc43.patch
Patch2: cmucl-19e-optflags.patch
BuildRequires: perl
BuildRequires: openmotif-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch: %{ix86}

%description
CMU Common Lisp is public domain "industrial strength"
Common Lisp programming environment.  Many of the X3j13 changes have
been incorporated into CMU CL.  Wherever possible, this has been done
so as to transparently allow use of either CLtL1 or proposed ANSI CL.
Probably the new features most interesting to users are SETF
functions, LOOP and the WITH-COMPILATION-UNIT macro.

%prep
%setup -q -c %{name}-%{version} %{?bootstrap_src}

%patch1 -p1 -b .gcc43
%patch2 -p1 -b .optflags

%build

%if %{bootstrap}
# Create target buildroot
src/tools/create-target.sh %{_target_platform} linux_gencgc %{cmucl_arch}
# Use binary-dist lisp to create initial kernel.core 
src/tools/build-world.sh %{_target_platform} bin/lisp
# build native lisp binary
src/tools/rebuild-lisp.sh %{_target_platform} 
# Generate lisp.core
src/tools/load-world.sh %{_target_platform} "%{version} Momonga release %{release}"
# rebuild kernel.core using native lisp 
src/tools/build-world.sh %{_target_platform} %{_target_platform}/lisp/lisp
# (Re)generate lisp.core
src/tools/load-world.sh %{_target_platform} "%{version} Momonga release %{release}"
# Build auxilary stuff
src/tools/build-utils.sh %{_target_platform} 
# make new binary dist archives
src/tools/make-dist.sh %{_target_platform} %{version} %{cmucl_arch} linux
%else
./src/tools/build.sh \
  -b %{_target_platform} \
  -C "linux_gencgc %{cmucl_arch}" \
  -v "%{version} Momonga release %{release}" \
  -o "/usr/bin/lisp -noinit -batch"

# make binary dist archives
./src/tools/make-dist.sh %{_target_platform}-4 %{version} %{cmucl_arch} linux
%endif

%install
rm -rf %{buildroot}

mkdir -p dist
pushd dist
# unarchive newly creating binary dist archives
tar xvzf ../cmucl-%{version}-x86-linux.tar.bz2
tar xvzf ../cmucl-%{version}-x86-linux.extra.tar.bz2

mkdir -p %{buildroot}%{_libdir}/cmucl/
cp -a bin %{buildroot}%{_libdir}/cmucl/
cp -a lib/cmucl %{buildroot}%{_libdir}/

mkdir -p %{buildroot}%{_mandir}/man1
install -p man/man1/* %{buildroot}%{_mandir}/man1
popd dist

## Setup app-wrapper
install -m755 -p -D lib/cmucl/sample-wrapper %{buildroot}%{_bindir}/cmucl
# Fixup paths in wrapper
perl -pi -e "s|^CMUCLLIB=.*|CMUCLLIB=%{_libdir}/cmucl/lib|" %{buildroot}%{_bindir}/cmucl
perl -pi -e "s|/<<your-cmucl-path>>|%{_libdir}/cmucl|"      %{buildroot}%{_bindir}/cmucl
# many apps (ie, maxima) expect to find the wrapper named 'lisp' too
ln -sf cmucl %{buildroot}%{_bindir}/lisp

# lisp.core contains environment used to build, including %{buildroot} 
QA_SKIP_BUILD_ROOT=1; export QA_SKIP_BUILD_ROOT

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root)
%if %{bootstrap}
%doc doc/cmucl/README 
#%doc doc/cmucl/release*.txt
%else
%doc dist/doc/cmucl/README dist/doc/cmucl/release*.txt
%endif
%{_bindir}/cmucl
%{_bindir}/lisp
%dir %{_libdir}/cmucl
%{_libdir}/cmucl/internals.inc
%{_libdir}/cmucl/bin
%dir %{_libdir}/cmucl/lib
%{_libdir}/cmucl/lib/lisp.core
%{_libdir}/cmucl/lib/load-foreign.csh
%{_libdir}/cmucl/lib/config
%{_libdir}/cmucl/lib/config.lisp
%{_libdir}/cmucl/lib/generic-site.lisp
%dir %{_libdir}/cmucl/lib/subsystems
%{_libdir}/cmucl/lib/subsystems/gray-*-library.x86f
%{_libdir}/cmucl/lib/subsystems/iodefs-library.x86f
%{_libdir}/cmucl/lib/subsystems/simple-*-library.x86f
%{_libdir}/cmucl/lisp.nm
%{_libdir}/cmucl/lisp.map
%{_libdir}/cmucl/internals.h
%{_libdir}/cmucl/sample-wrapper
%{_mandir}/man1/*
%{_libdir}/cmucl/lib/subsystems/clx-library.x86f
%{_libdir}/cmucl/lib/subsystems/hemlock-library.x86f
%{_libdir}/cmucl/lib/subsystems/clm-library.x86f
%{_libdir}/cmucl/lib/subsystems/external-formats-library.x86f
%{_libdir}/cmucl/lib/XKeysymDB
%{_libdir}/cmucl/lib/hemlock11.cursor
%{_libdir}/cmucl/lib/hemlock11.mask
%{_libdir}/cmucl/lib/spell-dictionary.bin
%{_libdir}/cmucl/lib/mh-scan
%{_libdir}/cmucl/lib/motifd
%{_libdir}/cmucl/lib/Linux-cmucl-linker-script
%{_libdir}/cmucl/lib/linker.sh
%{_libdir}/cmucl/lib/lisp.a
%dir %{_libdir}/cmucl/lib/ext-formats
%{_libdir}/cmucl/lib/ext-formats/iso8859-1.lisp
%{_libdir}/cmucl/lib/ext-formats/utf-8.lisp
%{_libdir}/cmucl/lib/ext-formats/void.lisp

%changelog
* Thu Jun 19 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- update cmucl-19e

* Fri Apr 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (19e-0.1m)
- update 19e-pre2
- import two patches from fc-devel
- disable bootstrap build by default
-- you can donwload a prebuild cmucl package from http://www.momonga-linux.org/~y/RPMS/

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (19d-4m)
- rebuild against gcc43

* Sat Feb 16 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (19d-3m)
- support newer binutils

* Thu Feb 14 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (19d-2m)
- %%NoSource -> NoSource

* Thu May 24 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (19d-1m)
- update 19d
- change Source URL

* Mon Nov 13 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (19c-2m)
- rebuild against openmotif-2.3.0-beta2

* Wed Jan 11 2006 Yohsuke Ooi <meme@momonga-linux.org> 
- (19c-1m)
- update 19c

* Sun Oct 31 2004 Masayuki SANO <nosanosa@momonga-linux.org> 
- (19a-1m)
- first import to Momonga
- import from http://apt.kde-redhat.org/kde-redhat/fedora/all/SRPMS.stable/

* Thu Aug 26 2004 Rex Dieter <rexdieter at sf.net> 0:19-0.fdr.2.a
- Fix Release: 19e -> 19a

* Wed Aug 04 2004 Rex Dieter <rexdieter at sf.net> 0:19-0.fdr.1.a
- cmucl-19a release
- nix -extras subpkg, for now

* Tue Mar 30 2004 Rex Dieter <rexdieter at sf.net> 0:18-0.fdr.2.e
- remove extraneous macros
- include URL's for all Source's.

* Fri Oct 10 2003 Rex Dieter <rexdieter at sf.net> 0:18-0.fdr.1.e
- first try.


